/**  
    Version "%W% %P% %G% %U%"
    EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
    See file "COPYRIGHT.txt" for conditions of use.
**/

/**************************************************************************
C PURPOSE:
C	returns TRUE iff time step for (JDATE,JTIME) is available
C	for variable VNAME in file with logical name FNAME.
C	
C
C PRECONDITIONS:
C	FNAME already opened by OPEN3() or open3c()
C	VNAME a valid variable in FNAME, or else is ALLVAR3=='ALL'
C
C CALLS:
C	Fortran I/O API's CHECK3()
C
C REVISION HISTORY:
C	Prototype 3/95 by CJC
C
**************************************************************************/

#include  <string.h>
#include  "iodecl3.h"


		/** HACKS FOR FELDMAN-DESCENDED F77'S FOLLOW: **/

#ifndef _WIN32            /* JEB */
#if FLDMN
#define CHECK3 check3_
#elif defined(__hpux) || defined(_AIX)
#define CHECK3 check3
#endif
#endif                    /* JEB */


#if defined(CHECK3)

		/** HACKS FOR FELDMAN-DESCENDED F77'S FOLLOW: **/

    extern int CHECK3( const char *fname ,
                       const char *vname ,
                       int        *jdate ,
                       int        *jtime ,
                       int         fnamelen ,
                       int         vnamelen ) ;

int check3c( const char *fname ,
             const char *vname ,
             int         jdate ,
             int         jtime )

    {       /*  begin body of check3c() */

    return CHECK3(   fname , 
                     vname , 
                   & jdate , 
                   & jtime , 
                     strlen( fname ) , 
                     strlen( vname ) ) ;

    }       /*  end body of check3c ()  */

#elif defined(_WIN32)

		/** HACKS FOR FELDMAN-DESCENDED F77'S FOLLOW: **/

    extern int CHECK3( const char *fname ,
                       int         fnamelen ,
                       const char *vname ,
                       int         vnamelen ,
                       int        *jdate ,
                       int        *jtime ) ;

int check3c( const char *fname ,
             const char *vname ,
             int         jdate ,
             int         jtime )

    {       /*  begin body of check3c() */

    return CHECK3(   fname , 
                     strlen( fname ) , 
                     vname , 
                     strlen( vname ) ,
                   & jdate , 
                   & jtime ) ;

    }       /*  end body of check3c ()  */

#elif defined(_CRAY)


#include <fortran.h>

    extern int CHECK3( const _fcd   fname ,
                       const _fcd   vname ,
                       int        * jdate ,
                       int        * jtime ) ;

int check3c( const char * fname ,
             const char * vname ,
             int          jdate ,
             int          jtime )
 
    {       /*  begin body of check3c() */
    
    _fcd  file ;
    _fcd  vble ;
    
    file = _cptofcd( (char *)fname, strlen( fname ) ) ;
    vble = _cptofcd( (char *)vname, strlen( vname ) ) ;

    return _btol( CHECK3(  file , 
                           vble , 
                         & jdate, 
                         & jtime ) ) ; 
                     
    }       /*  end body of check3c ()  */

                	/** END  CASE OF CRAY CF77-TARGETED check3c(): **/

#else

#error   "Error compiling check3c():  unsupported architecture"

#endif              /** IF FELDMAN-DESCENDED F77 TARGETED, OR IF CRAY **/

