
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        LOGICAL FUNCTION  CLOSE3 ( FNAME )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: CLOSE3
!DEC$ ENDIF
C***********************************************************************
C  function body starts at line  53
C
C  FUNCTION:  Flushes and closes down file with logical name FNAME
C
C  RETURN VALUE:  TRUE iff it succeeds.
C
C  PRECONDITIONS REQUIRED:  FNAME exists and has been opened
C
C  SUBROUTINES AND FUNCTIONS CALLED:  none
C
C  REVISION  HISTORY:  
C       prototype 8/95 by CJC
C
C***********************************************************************

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'PARMS3.EXT'
        INCLUDE 'STATE3.EXT'
        INCLUDE 'NETCDF.EXT'


C...........   ARGUMENTS and their descriptions:

        CHARACTER*(*)   FNAME   !  logical name of file to be opened


C...........   EXTERNAL FUNCTIONS and their descriptions:

        INTEGER         INDEX1  !  look up names in tables
        INTEGER         TRIMLEN
        EXTERNAL        INDEX1, TRIMLEN


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        INTEGER         FILE            !  file index
        INTEGER         V               !  vble index
        INTEGER         IERR            !  netCDF error status return
        CHARACTER*16    FIL16           !  scratch file-name buffer
        CHARACTER*80    MSGBUF


C***********************************************************************
C   begin body of function  CLOSE3

        IF ( .NOT. FINIT3 ) THEN
            CLOSE3 = .TRUE.
            RETURN
        END IF

        IF ( LEN( FNAME ) .GT. 16 ) THEN
            MSGBUF = 'File name length bad for "' // FNAME // '"'
            WRITE( LOGDEV,91010 )
     &          'Max length 16; actual:', LEN( FNAME ),
     &          MSGBUF
            CLOSE3 = .FALSE.
            RETURN
        END IF
        

C.......   Find netCDF index for the file, and check time step availability:

        FIL16 = FNAME   !  fixed-length-16 scratch copy of name
        FILE  = INDEX1( FIL16, COUNT3, FLIST3 )

        IF ( FILE .EQ. 0 ) THEN !  file not open.
            MSGBUF = 'File "' // FNAME( 1:TRIMLEN( FNAME ) ) //
     &               '" not currently open'
            WRITE( LOGDEV,91020 ) MSGBUF
            CLOSE3 = .FALSE.
            RETURN
        END IF

        IF( CDFID3( FILE ) .GE. 0 ) THEN
            CALL NCCLOS( CDFID3( FILE ), IERR )
            IF ( IERR .NE. 0 ) THEN
                MSGBUF =  'Error closing netCDF file "' // 
     &                    FNAME( 1:TRIMLEN( FNAME ) ) // '"'
                WRITE( LOGDEV,91010 ) 
     &                  'netCDF error number', IERR, MSGBUF
                CLOSE3 = .FALSE.
                RETURN
            END IF      !  if ierr nonzero
        END IF          !  if cdfid(file) positive or not

        CALL BUFDEL3( FILE )
        FLIST3( FILE ) = CMISS3
        DO  11 V = 1, NVARS3( FILE )
            ILAST3( V,FILE ) = IMISS3
            LDATE3( V,FILE ) = IMISS3
            LTIME3( V,FILE ) = IMISS3
            NDATE3( V,FILE ) = IMISS3
            NTIME3( V,FILE ) = IMISS3
11      CONTINUE
        
        MSGBUF = 'Closing file "' // FNAME( 1:TRIMLEN( FNAME ) ) // '"'
        WRITE( LOGDEV,92010 ) MSGBUF
        CLOSE3 = .TRUE.

        RETURN

C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91010   FORMAT ( //5X , '>>> WARNING in subroutine CLOSE3 <<<',
     &            3 ( /5X , A , : ) , I5, // )

91020   FORMAT ( //5X , '>>> WARNING in subroutine CLOSE3 <<<',
     &            3 ( /5X , A , : ) // )

C...........   Log message formats................... 92xxx

92010   FORMAT ( /5X , A, / )

        END

