
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        SUBROUTINE GETSTR ( PROMPT, DEFAULT, RESPONSE )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: GETSTR
!DEC$ ENDIF
C******************************************************************
C  function body begins at line 74
C
C  FUNCTION:
C
C       Safely get a character-string response from the keyboard (with
C       default value (<RETURN> response) supplied from caller.
C       Checks for validity of the response, and allows  MAX = 5 
C	unsuccessful attempts, then exits.  
C	Treats CONTROL-D (end-of-file) as exit signal.
C	Treats ! as initiation of a comment
C
C  REVISION HISTORY:
C
C       Prototype 9/94 by CJC
C       Modified  1/97 by CJC:  logs result
C
C  ARGUMENT LIST DESCRIPTION:
C
C    Input arguments:
C
C         PROMPT    prompt for user
C         DEFAULT   default value
C
C    Output arguments: none
C
C         RESPONSE  return value
C
C**********************************************************************


C.......   Arguments:

        CHARACTER*(*)   PROMPT, DEFAULT, RESPONSE


C.......   External functions:

        LOGICAL         ENVYN
        INTEGER         LBLANK, TRIMLEN
        EXTERNAL        ENVYN, LBLANK, TRIMLEN


C.......   Parameter:  maximum number of attempts allowed to the user

        INTEGER         MAX
        PARAMETER     ( MAX = 5 )


C.......   Local Variables:

        INTEGER         A1, P1, D1, R1, EE
        INTEGER         A0, P0, D0
        INTEGER         COUNT , IOS
        CHARACTER*256   PROMPT2, ANSWER, MESG

        LOGICAL         PROMPTON
        LOGICAL         FIRSTIME
        DATA            FIRSTIME / .TRUE. /
        SAVE            FIRSTIME, PROMPTON


C*********************   begin  GETSTR   *******************************

        IF( FIRSTIME ) THEN

            PROMPTON = ENVYN( 'PROMPTFLAG', 'Prompt for input flag',
     &                      .TRUE., IOS )
            FIRSTIME = .FALSE.
 
        END IF

        P0    = LBLANK ( PROMPT  ) + 1	!  initial position (first nonblank)
        D0    = LBLANK ( DEFAULT ) + 1	!  initial position (first nonblank)
        P1    = TRIMLEN( PROMPT  )	!  last nonblank
        D1    = TRIMLEN( DEFAULT )	!  last nonblank
        R1    = LEN( RESPONSE )

        PROMPT2 = PROMPT
        IF( .NOT. PROMPTON ) THEN
            IF ( D1 - D0 + 1 .GT. R1 ) THEN
                RESPONSE = DEFAULT( D0:R1 + D0 - 1 )
                MESG = 'Default "' // DEFAULT( D0:D1 )  //
     &                 ' truncated to "' // 
     &                  DEFAULT( D0:R1 + D0 - 1 ) // '" for query'
                CALL M3WARN( 'GETSTR', 0, 0, MESG )
                MESG = '"' // PROMPT2( P0:P1 ) // '"'
                CALL M3MESG( MESG )
            ELSE
                RESPONSE = DEFAULT( D0:D1 )
                WRITE( *,92010 ) 
     &              'Using default', DEFAULT( D0:D1 ), 'for query',
     &              PROMPT2( P0:P1 )
            END IF
            RETURN
        END IF

        COUNT = 0

11      CONTINUE
            ANSWER  =  '    '
            WRITE( *,95010 )  PROMPT2( P0:P1 ), DEFAULT( D0:D1 )
            READ ( *,93100, IOSTAT=IOS, ERR=900, END=999 )  ANSWER

            EE = INDEX( ANSWER, '!' )
            IF ( EE .NE. 0 ) ANSWER( EE : LEN( ANSWER ) ) = ' '

            A0 = LBLANK( ANSWER ) + 1		!  first nonblank
            IF ( A0 .GT. LEN( ANSWER ) ) THEN	!  all blanks
                IF ( D1 - D0 + 1 .GT. R1 ) THEN
                    RESPONSE = DEFAULT( D0:R1 + D0 - 1 )
                    MESG = 'Default "' // DEFAULT( D0:D1 )  //
     &                       ' truncated to "' //
     &                       DEFAULT( D0:R1 + D0 - 1 ) // '"'
                    CALL M3WARN( 'GETSTR', 0, 0, MESG )
                ELSE
                    RESPONSE = DEFAULT( D0: D1 )
                    WRITE( *,92010 ) 'Using default', DEFAULT( D0:D1 )
                END IF
            ELSE
                A1 = TRIMLEN( ANSWER )
                IF ( A1 - A0 + 1 .GT. R1 ) THEN
                    RESPONSE = ANSWER( A0:R1 + A0 - 1 )
                    MESG = 'Response "' // ANSWER( A0:A1 ) //
     &                     ' truncated to "' //
     &                     ANSWER( A0:R1 + A0 - 1 ) // '"'
                    CALL M3WARN( 'GETSTR', 0, 0, MESG )
                ELSE
                    RESPONSE = ANSWER( A0:A1 )
                    WRITE( *,92010 ) 'Using response', ANSWER( A0:A1 )
                END IF
            END IF
                   
            RETURN
             
900	CONTINUE	!  error reading response

            IF ( IOS .GT. 0 )  THEN
                COUNT  =  COUNT + 1
                IF ( COUNT .GE. MAX )  THEN
                    CALL  M3EXIT( 'GETSTR', 0, 0, 
     &                    'Maximum number of attempts exceeded.',IOS )
                END IF
                WRITE ( *,92020 ) 'Did not understand your response; ' ,
     &                  'I/O ERROR:  I/O status = ' , IOS ,
     &                  'Please try again (You are allowed ' ,
     &                  MAX - COUNT , ' more attempts)'
                GO TO  11
            END IF

999	CONTINUE	!  end-of-file reading response

        CALL  M3EXIT( 'GETSTR', 0, 0, 'END-OF-FILE encountered.', 1 )


C******************  FORMAT  STATEMENTS   ******************************

C...........   Informational (LOG) message formats... 92xxx

92010   FORMAT ( /5X , A , ' "', A, '"', :, 1X, A, 
     &           /5X ,'"', A, '"' )

92020   FORMAT ( /5X , A , /5X , A , I3 , /5X , A , I1 , A )


C...........   Formatted file I/O formats............ 93xxx

93100   FORMAT ( A )


C...........   Miscellaneous formats................. 95xxx

95010   FORMAT ( /5X , A , ' [' , A , '] >> ' , $ )

        END

