
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1999 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        LOGICAL FUNCTION INTLIST( ENAME, EDESC, NMAX, NCNT, LIST )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: INTLIST
!DEC$ ENDIF
C***********************************************************************
C  function body starts at line  57
C
C  RETURNS:  TRUE for success, FALSE for failure
C            Success implies NCNT > 0 ("we actually found something")
C
C  PRECONDITIONS REQUIRED:
C       setenv <logical name> <quoted, comma-delimited list of integers>
C       string-length( <list> <= 255
C
C  SUBROUTINES AND FUNCTIONS CALLED:
C       ENVINT, M3EXIT, STR2INT
C
C  REVISION  HISTORY:
C       prototype 04/15/98 by Carlie J. Coats, Jr., NCSC
C       Revised   02/09/99 by CJC:  NCNT <= 0:  failure
C
C***********************************************************************

      IMPLICIT NONE

C...........   ARGUMENTS and their descriptions:

        CHARACTER*(*)   ENAME   !  in:  environment variable for the list
        CHARACTER*(*)   EDESC   !  in:  environment variable description
        INTEGER         NMAX    !  in:  dimension for list
        INTEGER         NCNT    ! out:  actual number of entries in list
        INTEGER         LIST( NMAX )    ! out:  array of values found    

C...........   EXTERNAL FUNCTION:

        INTEGER         STR2INT
        EXTERNAL        STR2INT

C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        CHARACTER*256   BUF     !  buffer for environment-variable value
        CHARACTER*256   MSG     !  buffer for environment-variable value
        INTEGER         ISTAT   !  return status for ENVSTR
        INTEGER         L       !  subscript/loop counter
        INTEGER         LO, HI  !  substring bounds

C***********************************************************************
C   begin body of function  dummy

        CALL ENVSTR( ENAME, EDESC, ' ', BUF, ISTAT )
        IF ( ISTAT .NE. 0 ) THEN
            MSG = 'Could not get environment variable "'// ENAME// '"'
            CALL M3MSG2( MSG )
            INTLIST = .FALSE.
            RETURN
        END IF

        LO = 1
        HI = 0
        DO  L = 1, NMAX
            LO = LO + HI 
            HI = INDEX( BUF( LO : 256 ), ',' )
            IF ( HI .EQ. 0 ) HI = 257 - LO                   !  no more commas
            IF ( BUF( LO : LO+HI-1 ) .EQ. ' ' ) THEN
                NCNT = L - 1
                GO TO 99                !  list exhausted
            END IF
            LIST( L ) = STR2INT( BUF( LO : LO + HI - 1 ) )
            IF ( LO+HI .GE. 256 )  THEN
                NCNT = L
                GO TO 99                !  list exhausted
            END IF
        END DO

        IF ( LO+HI+1 .LT. 256 )  THEN   !  fall-through:  list done?
           IF ( BUF( LO+HI+1 : 256 ) .NE. ' ' )  THEN
               INTLIST = .FALSE.
               RETURN
            END IF
         END IF

99      CONTINUE        !  exit from loop
        INTLIST = ( NCNT .GT. 0 )
        RETURN
        END
