
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        LOGICAL FUNCTION  SHUT3 ( )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: SHUT3
!DEC$ ENDIF
C***********************************************************************
C  function body starts at line  39
C
C  FUNCTION:  Flushes and closes down all Models-3 files currently open.
C
C  RETURN VALUE:  TRUE iff it succeeds.
C
C  PRECONDITIONS REQUIRED:  none
C
C  SUBROUTINES AND FUNCTIONS CALLED:
C
C  REVISION  HISTORY:  
C       prototype 3/92 by CJC
C       Modified  8/95 by CJC to support CLOSE3()
C***********************************************************************

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'PARMS3.EXT'
        INCLUDE 'STATE3.EXT'
        INCLUDE 'NETCDF.EXT'


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        INTEGER         FILE            !  loop counter over files
        INTEGER         V               !  loop counter over vbles
        INTEGER         IERR            !  netCDF error status return

!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef IOAPICPL
        LOGICAL  SHUT3V
        EXTERNAL SHUT3V
#endif
!DEC$ ENDIF

C***********************************************************************
C   begin body of function  SHUT3

        SHUT3 = .TRUE.
        IF ( .NOT. FINIT3 ) THEN
            RETURN
        END IF

        DO  111  FILE = 1 , COUNT3

            IF( CDFID3( FILE ) .GE. 0 .AND. 
     &          FLIST3( FILE ) .NE. CMISS3 ) THEN
                CALL NCCLOS( CDFID3( FILE ), IERR )
                IF ( IERR .NE. 0 ) THEN
                    WRITE( LOGDEV,91010 )
     &                  'Error closing netCDF file ',
     &                  'File name:  ' // FLIST3( FILE ) ,
     &                  'netCDF error number', IERR
                    SHUT3 = .FALSE.
                END IF
            END IF

            CALL BUFDEL3( FILE )
            FLIST3( FILE ) = CMISS3
            DO  11 V = 1, NVARS3( FILE )
                ILAST3( V,FILE ) = IMISS3
                LDATE3( V,FILE ) = IMISS3
                LTIME3( V,FILE ) = IMISS3
                NDATE3( V,FILE ) = IMISS3
                NTIME3( V,FILE ) = IMISS3
11          CONTINUE

111     CONTINUE        !  end loop on files

        COUNT3 = IMISS3
        FINIT3 = .FALSE.

!DEC$ IF DEFINED (_WIN32)
!DEC$ ELSE
#ifdef  IOAPICPL
        SHUT3 = SHUT3V()
#endif
!DEC$ ENDIF

        RETURN

C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91010   FORMAT ( //5X , '>>> WARNING in subroutine SHUT3 <<<',
     &            3 ( /5X , A , : ) , I5, // )

        END

