
C Version "%W% %P% %G% %U%

        SUBROUTINE  MMPTHETA( NCOLS, NROWS, NLAYS, PLEV, TA, THETA )

C***********************************************************************
C  subroutine body starts at line  75
C
C  FUNCTION:  Compute 3D potential temperature THETA from
C	pressure levels PLEV and 3D  temperature TA.
C
C
C  PRECONDITIONS REQUIRED:
C       ioapi gridded PRES, TA from MMPDTRH
C
C  SUBROUTINES AND FUNCTIONS CALLED: none
C
C  REVISION  HISTORY:
C       Prototype Feb. 23, 1999 by Carlie J. Coats, Jr., MCNC
C
C***********************************************************************

      IMPLICIT NONE

C...........   ARGUMENTS and their descriptions:

        INTEGER         NCOLS   !  output dimension
        INTEGER         NROWS   !  " 
        INTEGER         NLAYS   !  "
        REAL            PLEV ( NLAYS ) !  pressure (Pa)
        REAL            TA   ( NCOLS, NROWS, NLAYS ) !  temperature (K)
        REAL            THETA( NCOLS, NROWS, NLAYS ) !  potential temperature

C...........   PARAMETERs

        REAL	    	RDGAS		 !  from param.F, line 1573 & ff
	REAL            CP		 !  "
	REAL            ROVCP		 !  Celsius-to-Kelvin

        PARAMETER     ( RDGAS =  287.04, !  to preserve MM5 compatibility
     &                  CP    = 1004.0 , !  "
     &                  ROVCP = RDGAS / CP )

C...........   SCRATCH LOCAL VARIABLES and their descriptions:

	INTEGER		C, R, L		 !  IOAPI col subscript
        REAL            FAC, PFAC        !  subexpressions within
                                         !  TA*(1.0E5/PRES)**(RDGAS/CP)

C***********************************************************************
C   begin body of subroutine  MM2DPT

        FAC = 1.0E5**ROVCP

        DO  L = 1, NLAYS  !! here nlays is number of pres-coordinate layers

            PFAC = FAC * PLEV( L )**(-ROVCP)

            DO  R = 1, NROWS
            DO  C = 1, NCOLS
                THETA( C,R,L ) = PFAC * TA( C,R,L )
            END DO
            END DO

        END DO

        RETURN
        END
